# Python code for DuneWars
# Version 1.7.3.2 last updated 4/17/10 Deliverator

from CvPythonExtensions import *
import time
import math
import operator
import CvCameraControls
import MercenaryUtils # koma13
import Popup as PyPopup
import CvUtil
import BugUtil

gc = CyGlobalContext()
DuneWarsInst = ""
objMercenaryUtils = MercenaryUtils.MercenaryUtils() #koma13

# Entry points from CvGameUtils.  If you add one, update config/init.xml

def cannotTrain(argsList):
	pCity, eUnit, bContinue, bTestVisible, bIgnoreCost, \
		bIgnoreUpgrades = argsList
        return DuneWarsInst.cannotTrain(pCity, eUnit)

def cannotConstruct(argsList):
	pCity, eBuilding, bContinue, bTestVisible, bIgnoreCost = argsList
        return DuneWarsInst.cannotConstruct(pCity, eBuilding)

def AI_unitUpdate(argsList):
        return DuneWarsInst.AI_unitUpdate(argsList[0])

def getWidgetHelp(argsList):
	eWidgetType, iData1, iData2, bOption = argsList
	if iData1 == 667: 
		return CyTranslator().getText("TXT_KEY_HW_VERSION", ())
	return u""
 
def getUpgradePriceOverride(argsList):
	iPlayer, iUnitID, iUnitTypeUpgrade = argsList
	return DuneWarsInst.getUpgradePriceOverride(iPlayer, \
		iUnitID, iUnitTypeUpgrade)

# Entry points from CvRandomEventsInterface.py

def ContractCan(argsList, sType):
	return DuneWarsInst.ContractCan(argsList, sType)

def ContractDo(argsList, sType):
	return DuneWarsInst.ContractDo(argsList, sType)

def ContractHelp(argsList, sType):
	return DuneWarsInst.ContractHelp(argsList, sType)

def MentatDo(argsList, sType):
	return DuneWarsInst.MentatDo(argsList, sType)

def MentatHelp(argsList, sType):
	return DuneWarsInst.MentatHelp(argsList, sType)

# Abomination Trait
def AbominationDo(argsList):
	iEvent = argsList[0]
	kTriggeredData = argsList[1]
	iPlayer = kTriggeredData.ePlayer
	pPlayer = gc.getPlayer(iPlayer)
	for i in range(gc.getNumTraitInfos()):
		if (pPlayer.hasTrait(i) and i != gc.getInfoTypeForString('TRAIT_ABOMINATION')):
			pPlayer.setHasTrait(i, False)
	Traits = [ 'TRAIT_AGGRESSIVE','TRAIT_CHARISMATIC','TRAIT_CREATIVE','TRAIT_EXPANSIVE','TRAIT_FINANCIAL','TRAIT_INDUSTRIOUS','TRAIT_ORGANIZED','TRAIT_PHILOSOPHICAL','TRAIT_SPIRITUAL' ]
	iRnd1 = CyGame().getSorenRandNum(len(Traits), "Abomination")
	iRnd2 = CyGame().getSorenRandNum(len(Traits), "Abomination")
	while iRnd2 == iRnd1:
		iRnd2 = CyGame().getSorenRandNum(len(Traits), "Abomination")
	pPlayer.setHasTrait(gc.getInfoTypeForString(Traits[iRnd1]),True)
	pPlayer.setHasTrait(gc.getInfoTypeForString(Traits[iRnd2]),True)
	
# Entry points from CvMainInterface.py
def StormDraw():
	DuneWarsInst.StormDraw()

# Entry points from CvVictoryScreen.py

def TerraVictoryPlots():
	return DuneWarsInst.TerraVictoryPlots()

def TerraVictoryPlayer(iPlay):
	return DuneWarsInst.TerraVictoryPlayer(iPlay)

def SpiceVictoryRequiredBonuses():
	return DuneWarsInst.SpiceVictoryRequiredBonuses()
	
def SpiceVictoryFixedAmount():
	return DuneWarsInst.SpiceVictoryFixedAmount()

def SpiceVictoryGetPercentage():
	return DuneWarsInst.SpiceVictoryGetPercentage()

def SpiceVictoryPlayer(iPlay):
	return DuneWarsInst.SpiceVictoryPlayer(iPlay)

class DuneWars:

	### PUBLIC ENTRY POINTS

	# Initialize, called from BUG init
	def __init__(self, customEM, configfile):
		global DuneWarsInst
		self.bInitialized = false
		DuneWarsInst = self
		# Event handlers
		customEM.addEventHandler("improvementBuilt", self.onImprovementBuilt)
		customEM.addEventHandler("buildingBuilt", self.onBuildingBuilt)
		customEM.addEventHandler("projectBuilt", self.onProjectBuilt)		
		customEM.addEventHandler("ModNetMessage", self.onModNetMessage)
		customEM.addEventHandler("EndGameTurn", self.onEndGameTurn)
		customEM.addEventHandler("BeginPlayerTurn", self.onBeginPlayerTurn)		
		customEM.addEventHandler("combatResult", self.onCombatResult)
		customEM.addEventHandler("GameStart", self.onGameStart)
		customEM.addEventHandler("unitCreated", self.onUnitCreated)
		customEM.addEventHandler("unitBuilt", self.onUnitBuilt)
		customEM.addEventHandler("OnLoad", self.onGameLoad)
		customEM.addEventHandler("PythonReloaded", self.onGameLoad)
		customEM.addEventHandler("cityRazed", self.onCityRazed)
		customEM.addEventHandler("cityBuilt", self.onCityBuilt)
		customEM.addEventHandler("cityAcquired", self.onCityAcquired)
		customEM.addEventHandler("religionSpread", self.onReligionSpread)

		# Shortcut keys for camera control
		customEM.addShortcutHandler("shift left", self.CameraSL)
		customEM.addShortcutHandler("ctrl left", self.CameraCL)
		customEM.addShortcutHandler("shift right", self.CameraSR)
		customEM.addShortcutHandler("ctrl right", self.CameraCR)
		customEM.addShortcutHandler("shift up", self.CameraSCU)
		customEM.addShortcutHandler("ctrl up", self.CameraSCU)
		customEM.addShortcutHandler("shift down", self.CameraSCD)
		customEM.addShortcutHandler("ctrl down", self.CameraSCD)
		customEM.addShortcutHandler("ctrl home", self.CameraCH)

	# AI movement
	def AI_unitUpdate(self, pUnit):
		self.Initialize()
		iType = pUnit.getUnitType()
		if self.dWormUnits.has_key(iType): return self.WormAI(pUnit)
		if pUnit.getUnitType() == self.iUMentat:
			return self.MentatAI(pUnit)
		return false

	# Require Way of Liet civic to build catchbasin and reservoir
	def cannotConstruct(self, pCity, iBuilding):
		self.Initialize()
		pPlay = gc.getPlayer(pCity.getOwner())
		if ((iBuilding == self.iBCatch) or (iBuilding == self.iBLiet)) and pPlay.getCivics(self.iCArrak) != self.iCPara:
			return true
		elif (iBuilding == self.iBSSilo) and pPlay.getCivics(self.iCArrak) != self.iCSpind: 
			return true
		elif (iBuilding == self.iBFrcSld) and (pCity.getNumRealBuilding(self.iBHseSld) > 0): 
			return true
		# ALN - no Political Office in Capital
		if (iBuilding == self.iBPolOff) and (pCity.isCapital()):
			return true
		return false

	# Require Spice Industry civic to build spice worker
	def cannotTrain(self, pCity, iUnitType):
		self.Initialize()
		if iUnitType == self.iUSpwork:
			pPlay = gc.getPlayer(pCity.getOwner())
			if pPlay.getCivics(self.iCArrak) != self.iCSpind:
				return true
		return false

	# Ixian Skunkworks provides half price upgrade
	def getUpgradePriceOverride(self, iPlayer, iUnitID, iUnitUpgradeType):
		self.Initialize()
		pPlayer = gc.getPlayer(iPlayer)
		pUnit = pPlayer.getUnit(iUnitID)
		if not pUnit.plot().isCity(): return -1
		pCity = pUnit.plot().getPlotCity()
		if pCity.getNumRealBuilding(self.iBSkunk) == 0: return -1
		# In a city with a skunkworks; compute cost
		# Inspired by Leonardo's Workshop wonder by tsentom1
		iPrice = gc.getDefineINT("BASE_UNIT_UPGRADE_COST")
		iMax = max(0, (pPlayer.getUnitProductionNeeded(iUnitUpgradeType) - pPlayer.getUnitProductionNeeded(pUnit.getUnitType())))
		iPrice += iMax * gc.getDefineINT("UNIT_UPGRADE_COST_PER_PRODUCTION")
		if ((not pPlayer.isHuman()) and (not pPlayer.isBarbarian())):
			pHandicapInfo = gc.getHandicapInfo(gc.getGame().getHandicapType())
			iPrice *= pHandicapInfo.getAIUnitUpgradePercent() / 100
			iMax = max(0, ((pHandicapInfo.getAIPerEraModifier() * pPlayer.getCurrentEra()) + 100))
			iPrice *= iMax / 100
		iPrice -= (iPrice * pUnit.getUpgradeDiscount()) / 100
		return 75 * iPrice / 100

	### CAMERA CONTROL

	def CameraCL(self, argsList):
		CyCamera().SetBaseTurn(CyCamera().GetBaseTurn() - 45.0)

	def CameraSL(self, argsList):
		CyCamera().SetBaseTurn(CyCamera().GetBaseTurn() - 15.0)

	def CameraCR(self, argsList):
		CyCamera().SetBaseTurn(CyCamera().GetBaseTurn() + 45.0)

	def CameraSR(self, argsList):
		CyCamera().SetBaseTurn(CyCamera().GetBaseTurn() + 15.0)

	def CameraSCU(self, argsList):
		if CyCamera().GetBasePitch() > -45:
			CyCamera().SetBasePitch(CyCamera().GetBasePitch() - 5.0)

	def CameraSCD(self, argsList):
		if CyCamera().GetBasePitch() < 20:
			CyCamera().SetBasePitch(CyCamera().GetBasePitch() + 5.0)

	def CameraCH(self, argsList):
		CyCamera().SetBaseTurn(0)
		CyCamera().SetBasePitch(0)

	### EVENT MANAGER ENTRY POINTS

	# Take multiple actions at the end of each player turn
	def onEndGameTurn(self, argsList):
		self.Initialize()
		iGameTurn = argsList[0]
		self.Dequeue() # results of AI actions
		(iUnowned, iWormCount, iSpiceCount, iMaxStr) = self.Count()
		self.BlowAdd(iSpiceCount, false)
		self.SpiceDecay()
		self.SpiceBlow()
		self.WormAdd(iUnowned, iWormCount, iMaxStr)
		self.StormRun()
		self.UnitLoop()
		self.PlagueCities()
		self.MentatCities()
		self.Terraform()
		self.TerraVictoryCheck()
		self.SpiceVictoryCheck()
		objMercenaryUtils.doHomeworld() # koma13
		self.Dequeue() # results of end of turn actions
		# not for release: self.StatPrint(iGameTurn)

	def onBeginPlayerTurn(self, argsList):
		iGameTurn, iPlayer = argsList
		pPlayer = gc.getPlayer(iPlayer)	
		if pPlayer.hasTrait(gc.getInfoTypeForString('TRAIT_ABOMINATION')):
			if CyGame().getSorenRandNum(1000, "Insane") < 20:
				iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_TRAIT_ABOMINATION')
				triggerData = pPlayer.initTriggeredData(iEvent, true, -1, -1, -1, iPlayer, -1, -1, -1, -1, -1)
		
	# Receive modnetmessage for various button presses
	def onModNetMessage(self, argsList):
		iMessageID, iData2, iData3, iData4, iData5 = argsList
		if iMessageID == 690:
			# Homeworld Screen: koma13
			pCity, pUnit = objMercenaryUtils.placeMercenaries(argsList)
			self.onUnitBuilt([pCity, pUnit])

	# If water improvement built: add windtrap feature, and if
	#    spice or a blow is nearby remove it.
	# If something else built, and windtrap feature is here, remove
	#    windtrap feature of fresh water.  Game does not call oiD for
	#    this case, but it should.
	# If the improvement is a desalinator, remove it and change terrain
	# If a slave is here, assume it was used, and destroy it.
	def onImprovementBuilt(self, argsList):
		self.Initialize()
		iImpr, cx, cy = argsList
		pPlot = CyMap().plot(cx, cy)
		if gc.getImprovementInfo(iImpr).getAddsFreshWaterInRadius() >= 0:
			self.RemoveSpiceNearby(cx, cy, gc.getImprovementInfo(iImpr).getAddsFreshWaterInRadius())
		if iImpr == self.iIDesal:
			pPlot.setTerrainType(self.iTGrab, true, true)
			pPlot.setImprovementType(-1)
		self.RemoveSlave(pPlot)

	# If water improvement destroyed, remove windtrap feature
	#def onImprovementDestroyed(self, argsList):
	#	self.Initialize()
	#	iImpr, iOwner, cx, cy = argsList
	#	if self.dFreshI.has_key(iImpr):
	#		pPlot = CyMap().plot(cx, cy)
	#		pPlot.setFeatureType(-1, 0)

	# Perform several actions when new building built
	def onBuildingBuilt(self, argsList):
		pCity, iBldgType = argsList
		self.Initialize()
		iPlay = pCity.getOwner()
		pPlay = gc.getPlayer(iPlay)
		# If water building built, add water feature and remove spice
		if self.dFreshB.has_key(iBldgType):
			pPlot = pCity.plot()
			if iBldgType == self.iBLiet:
				r = 3
			else:
				r = 1
			pPlot.changeFreshWaterInRadius(1, r)	
			self.RemoveSpiceNearby(pPlot.getX(), pPlot.getY(), r)

		# If landing stage or haven, trigger event for contract
		if (iBldgType == self.iBStage):
			pPlay.initTriggeredData(self.iEStage, true, 
				pCity.getID(), pCity.getX(), pCity.getY(), -1,
				-1, -1, -1, -1, -1)
				
		# When Great Convention Breached! Building is complete, create 3 Atomics in Capital
		if (iBldgType == self.iBConvBreach):				
			pCapital = pPlay.getCapitalCity()	
			for i in range(1, 4):
				pNew = pPlay.initUnit(self.iUAtomic, pCapital.getX(), pCapital.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)		
				
	def onProjectBuilt(self, argsList):
		# Create Monitor Warship in Capital when all five Monitor Projects are complete
		pCity, iProjType = argsList
		self.Initialize()
		iPlay = pCity.getOwner()
		pPlay = gc.getPlayer(iPlay)
		pTeam = gc.getTeam(pPlay.getTeam())
		pCapital = pPlay.getCapitalCity()
		iMonProjs = 0
		
		if iProjType in self.lMonitorProj:
			for iProj in self.lMonitorProj:
				iMonProjs = iMonProjs + pTeam.getProjectCount(iProj)

		if (iMonProjs == 4):
			pNew = pPlay.initUnit(self.iUMonitor, pCapital.getX(), pCapital.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
		

	# Remove fresh water from catchbasin and reservoir on raze
	def onCityRazed(self, argsList):
		pCity, iPlay = argsList
		pPlot = pCity.plot()
		for iBldg in self.dFreshB.keys():
			if pCity.getNumRealBuilding(iBldg) > 0:
				if iBldg == self.iBLiet:
					r = 3
				else:
					r = 1
				pPlot.changeFreshWaterInRadius(-1, r)	

	# Check several civilization abilities upon combat result
	def onCombatResult(self, argsList):
		self.Initialize()
		pWinUnit, pLoseUnit = argsList
		pWinPlay = gc.getPlayer(pWinUnit.getOwner())
		iWinCiv = pWinPlay.getCivilizationType()
		# If Harkonnen winner, maybe build slave unit
		if iWinCiv == self.iCHark:
			self.CombatCapture(pLoseUnit, pWinPlay, pWinUnit, true)
		# If Fremen winner, maybe capture
		if iWinCiv == self.iCFrem:
			self.CombatCapture(pLoseUnit, pWinPlay, pWinUnit, false)
		pLosePlay = gc.getPlayer(pLoseUnit.getOwner())
		# If Tleilaxu combat, maybe spread plague
		if pLosePlay.getCivilizationType() == self.iCTlei:
			self.SpreadPlague(pWinUnit)

	# Perform several steps when game loads (or starts, or python reloaded)
	def onGameLoad(self, argsList):
		self.Initialize()
		self.ContractStart()
		# Store index of Tleilaxu player, if any
		self.iPTlei = -1
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			if pPlay.getCivilizationType() == self.iCTlei:
				self.iPTlei = iPlay
		# Create list of ocean plots
		self.lOcean = []
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			if pPlot.getTerrainType() == self.iTOcean:
				self.lOcean.append(pPlot)

	# Perform several steps when game starts
	def onGameStart(self, argsList):
		self.onGameLoad([])
		# Place initial spice
		self.BlowAdd(0, true)
		# Remove several terrains which may be added by mapscripts
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			iType = pPlot.getTerrainType()
			if iType == self.iTTGrass:
				pPlot.setTerrainType(self.iTRock, true, true)
			elif iType == self.iTTPlain:
				pPlot.setTerrainType(self.iTRug, true, true)
		# For Fremen units, give them the default promotion
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			if pPlay.getCivilizationType() != self.iCFrem: continue
			(pUnit, iter) = pPlay.firstUnit(false)
			while (pUnit):
				self.FremenPromotion(pUnit)
				(pUnit, iter) = pPlay.nextUnit(iter, false)
		# Initialize storm storage
		CyMap().plot(0,0).setScriptData("")

	# Check Fremen promotion when unit created.  Notes: this is called
	# in CvUnit::init, so there is no valid city, and onUnitBuilt is
	# called later.  Don't do stuff twice.  The reason is to add the
	# Fremen sandrider promotion onto the unit, so units popped from
	# goody huts will get it.
	def onUnitCreated(self, argsList):
		pUnit = argsList[0]
		self.Initialize()
		self.FremenPromotion(pUnit)

	# Check several conditions when unit built
	def onUnitBuilt(self, argsList):
		pCity, pUnit = argsList
		self.Initialize()
		iPlay = pUnit.getOwner()
		if iPlay == self.iPTlei: self.TleilaxuClone(pCity, pUnit)
		if pUnit.getUnitType() == self.iUMentat:
			self.MentatBuilt(pUnit)

	# Check several conditions when city is built
	def onCityBuilt(self, argsList):
		pCity = argsList[0]
		self.Initialize()
		iOwner = pCity.getOwner()
		# Add Tlei religion if Tlei city; add holy city for capital
		if iOwner == self.iPTlei:
			pCity.setHasReligion(self.iRTlei, true, false, false)
			if pCity.isCapital():
				CyGame().setHolyCity(self.iRTlei, pCity, true)
		# If not capitol or Fremen, assign name from global list
		pPlay = gc.getPlayer(iOwner)
		iCiv = pPlay.getCivilizationType()
		if (not pCity.isCapital()) and (iCiv != self.iCFrem):
			pCity.setName(self.MakeCityName(pCity), false)

	# Check several conditions when city changes hands
	def onCityAcquired(self, argsList):
		iPreviousOwner,iNewOwner,pCity,bConquest,bTrade = argsList
		self.Initialize()
		# Add/remove Tleilaxu religion if city now owned/not by Tlei
		if iNewOwner == self.iPTlei:
			pCity.setHasReligion(self.iRTlei, true, false, false)
		else:
			pCity.setHasReligion(self.iRTlei, false, false, false)
		# If conqueror state religion is Mahdi, spread it
		pOwner = gc.getPlayer(iNewOwner)
		if pOwner.getStateReligion() == self.iRMahdi:
			pCity.setHasReligion(self.iRMahdi, true, false, false)

	# Religion has spread to a city.  If Imperial is there remove it.
	# If Qizarate is the one spreading, remove all others.
	def onReligionSpread(self, argsList):
		iReligion, iOwner, pCity = argsList
		if pCity.isHasReligion(self.iRImp) and iReligion != self.iRImp:
			pCity.setHasReligion(self.iRImp, false, false, false)
		if iReligion == self.iRQiz:
			for i in range(gc.getNumReligionInfos()):
				if i == self.iRQiz: continue
				if pCity.isHasReligion(i):
					pCity.setHasReligion(i, false, false, false)

	### LOW LEVEL SUBROUTINES

	# Unsafe to perform getInfoTypeForString without checking success
	def GetCheckInfo(self, s):
		iVal = gc.getInfoTypeForString(s)
		if iVal == -1: self.DebugPrint ("GCI: Unable to find " + s)
		return iVal

	def Initialize(self):
		if self.bInitialized: return
		self.bInitialized = true
		self.DebugFilename = "c:\\stats.csv"

		self.iBonusSapho  = self.GetCheckInfo("BONUS_SAPHO")
		self.iBSpice  = self.GetCheckInfo("BONUS_SPICE")
		self.iBWCSat  = self.GetCheckInfo("BUILDINGCLASS_WEATHER_CONTROL_SATELLITE")
		self.iBPolOff = self.GetCheckInfo("BUILDING_POLITICAL_OFFICE")
		self.iBAxlotl = self.GetCheckInfo("BUILDING_AXLOTL_TANK")
		self.iBCatch  = self.GetCheckInfo("BUILDING_CATCHBASIN")
		self.iBLiet   = self.GetCheckInfo("BUILDING_RESERVOIR_OF_LIET")
		self.iBSSilo  = self.GetCheckInfo("BUILDING_SPICE_SILO")
		self.iBStage  = self.GetCheckInfo("BUILDING_LANDING_STAGE")
		self.iBPlague = self.GetCheckInfo("BUILDING_TLEILAXU_PLAGUE")
		self.iBSkunk  = self.GetCheckInfo("BUILDING_IXIAN_SKUNKWORKS")
		self.iBIxWeap = self.GetCheckInfo("BUILDING_IX_WEAP_CONTRACT")
		self.iBKind   = self.GetCheckInfo("BUILDING_KINDJAL_CONTRACT")
		self.iBLabor  = self.GetCheckInfo("BUILDING_LABOR_CONTRACT")
		self.iBPundi  = self.GetCheckInfo("BUILDING_PUNDI_RICE_CONTRACT")
		self.iBOpaf   = self.GetCheckInfo("BUILDING_OPAFIRE_CONTRACT")
		self.iBSardau = self.GetCheckInfo("BUILDING_SARDAUKAR_CONTRACT")
		self.iBSemu   = self.GetCheckInfo("BUILDING_SEMUTA_CONTRACT")
		self.iBSlig   = self.GetCheckInfo("BUILDING_SLIG_CONTRACT")
		self.iBSoo    = self.GetCheckInfo("BUILDING_SOOSTONE_CONTRACT")
		self.iBWine   = self.GetCheckInfo("BUILDING_CALADANIAN_WINE_CONTRACT")
		self.iBSapho  = self.GetCheckInfo("BUILDING_SAPHO_JUICE_CONTRACT")
		self.iBLabor  = self.GetCheckInfo("BUILDING_LABOR_CONTRACT")
		self.iBFrcSld = self.GetCheckInfo("BUILDING_FORCE_SHIELD")	
		self.iBHseSld = self.GetCheckInfo("BUILDING_HOUSE_SHIELD_GENERATOR")	
		self.iBConvBreach = self.GetCheckInfo("BUILDING_GREAT_CONVENTION_BREACHED")
		self.iCArrak  = self.GetCheckInfo("CIVICOPTION_ARRAKIS")
		self.iCPara   = self.GetCheckInfo("CIVIC_ARRAKIS_PARADISE")
		self.iCSpind  = self.GetCheckInfo("CIVIC_ARRAKIS_SPICE")
		self.iCAtre   = self.GetCheckInfo("CIVILIZATION_ATREIDES")
		self.iCCorr   = self.GetCheckInfo("CIVILIZATION_CORRINO")
		self.iCEcaz   = self.GetCheckInfo("CIVILIZATION_ECAZ")
		self.iCFrem   = self.GetCheckInfo("CIVILIZATION_FREMEN")
		self.iCGess   = self.GetCheckInfo("CIVILIZATION_GESSERIT")
		self.iCHark   = self.GetCheckInfo("CIVILIZATION_HARKONNEN")
		self.iCIx     = self.GetCheckInfo("CIVILIZATION_IX")
		self.iCOrdos  = self.GetCheckInfo("CIVILIZATION_ORDOS")
		self.iCTlei   = self.GetCheckInfo("CIVILIZATION_TLEILAX")
		self.iCBarb   = self.GetCheckInfo("CIVILIZATION_BARBARIAN")
		self.iESandL  = self.GetCheckInfo("EFFECT_SANDSTORM_LIGHT")
		self.iESandD  = self.GetCheckInfo("EFFECT_SANDSTORM_DARK")
		self.iERain   = self.GetCheckInfo("EFFECT_RAINSTORM")
		self.iEStage  = self.GetCheckInfo("EVENTTRIGGER_CONTRACT")
		self.iEMentat = self.GetCheckInfo("EVENTTRIGGER_MENTAT")
		self.iFBlow   = self.GetCheckInfo("FEATURE_SPICEBLOW")
		self.iFFresh  = self.GetCheckInfo("FEATURE_WINDTRAP")
		self.iFSpice  = self.GetCheckInfo("FEATURE_SPICE")
		self.iFOasis  = self.GetCheckInfo("FEATURE_OASIS")
		self.iFForest = self.GetCheckInfo("FEATURE_FOREST")		
		self.iFArch   = self.GetCheckInfo("FEATURE_ROCK_ARCH")
		self.iFArch2  = self.GetCheckInfo("FEATURE_ROCK_ARCH2")		
		self.iFRock1  = self.GetCheckInfo("FEATURE_ROCK_FORM1")
		self.iFRock2  = self.GetCheckInfo("FEATURE_ROCK_FORM2")
		self.iFRock3  = self.GetCheckInfo("FEATURE_ROCK_FORM3")
		self.iFRock4  = self.GetCheckInfo("FEATURE_ROCK_FORM4")
		self.iFPArch  = self.GetCheckInfo("FEATURE_POLAR_ROCK_ARCH")
		self.iFPArch2 = self.GetCheckInfo("FEATURE_POLAR_ROCK_ARCH2")		
		self.iFPRock1 = self.GetCheckInfo("FEATURE_POLAR_ROCK_FORM1")
		self.iFPRock2 = self.GetCheckInfo("FEATURE_POLAR_ROCK_FORM2")
		self.iFPRock3 = self.GetCheckInfo("FEATURE_POLAR_ROCK_FORM3")
		self.iFPRock4 = self.GetCheckInfo("FEATURE_POLAR_ROCK_FORM4")	
		self.iFDArch  = self.GetCheckInfo("FEATURE_DARK_ROCK_ARCH")
		self.iFDArch2 = self.GetCheckInfo("FEATURE_DARK_ROCK_ARCH2")		
		self.iFDRock1 = self.GetCheckInfo("FEATURE_DARK_ROCK_FORM1")
		self.iFDRock2 = self.GetCheckInfo("FEATURE_DARK_ROCK_FORM2")
		self.iFDRock3 = self.GetCheckInfo("FEATURE_DARK_ROCK_FORM3")
		self.iFDRock4 = self.GetCheckInfo("FEATURE_DARK_ROCK_FORM4")			
		self.iFPeak1  = self.GetCheckInfo("FEATURE_PEAK1")
		self.iFPeak2  = self.GetCheckInfo("FEATURE_PEAK2")		
		self.iFPeak3  = self.GetCheckInfo("FEATURE_PEAK3")		
		self.iIHarv   = self.GetCheckInfo("IMPROVEMENT_HARVESTER")
		self.iIHut    = self.GetCheckInfo("IMPROVEMENT_GOODY_HUT")
		self.iIDesal  = self.GetCheckInfo("IMPROVEMENT_DESALINATOR")
		self.iPCbt1   = self.GetCheckInfo("PROMOTION_COMBAT1")
		self.iPCbt2   = self.GetCheckInfo("PROMOTION_COMBAT2")
		self.iPCbt3   = self.GetCheckInfo("PROMOTION_COMBAT3")
		self.iPCbt4   = self.GetCheckInfo("PROMOTION_COMBAT4")
		self.iPDri1   = self.GetCheckInfo("PROMOTION_DRILL1")
		self.iPDri2   = self.GetCheckInfo("PROMOTION_DRILL2")
		self.iPDri3   = self.GetCheckInfo("PROMOTION_DRILL3")
		self.iPHome   = self.GetCheckInfo("PROMOTION_HOMEGROUND")
		self.iPInspir = self.GetCheckInfo("PROMOTION_INSPIRED1")
		self.iPPlague = self.GetCheckInfo("PROMOTION_PLAGUE")
		self.iPSandW  = self.GetCheckInfo("PROMOTION_SANDWORKER")
		self.iPSand   = self.GetCheckInfo("PROMOTION_SANDRIDER")
		self.iPStill  = self.GetCheckInfo("PROMOTION_STILLSUIT")		
		self.iPThump  = self.GetCheckInfo("PROMOTION_THUMPER")
		self.iRImp    = self.GetCheckInfo("RELIGION_IMPERIAL")
		self.iRMahdi  = self.GetCheckInfo("RELIGION_MAHDI")
		self.iRQiz    = self.GetCheckInfo("RELIGION_QIZARATE")
		self.iRTlei   = self.GetCheckInfo("RELIGION_TLEILAXU")
		self.iTSpice  = self.GetCheckInfo("TECH_SPICE_EXTRACTION")
		self.iTGrab   = self.GetCheckInfo("TERRAIN_PLAINS")
		self.iTOcean  = self.GetCheckInfo("TERRAIN_OCEAN")
		self.iTCoast  = self.GetCheckInfo("TERRAIN_COAST")
		self.iTPolar  = self.GetCheckInfo("TERRAIN_POLAR")
		self.iTPCoast = self.GetCheckInfo("TERRAIN_POLAR_COAST")
		self.iTRock   = self.GetCheckInfo("TERRAIN_GRASS")
		self.iTRug    = self.GetCheckInfo("TERRAIN_SNOW")
		self.iTSalt   = self.GetCheckInfo("TERRAIN_SALT")
		self.iTTGrass = self.GetCheckInfo("TERRAIN_TERRA_GRASS")
		self.iTTPlain = self.GetCheckInfo("TERRAIN_TERRA_PLAINS")
		self.iTDunes  = self.GetCheckInfo("TERRAIN_DESERT")
		self.iUFremS  = self.GetCheckInfo("UNIT_FREMEN_SCOUT")
		self.iUSlave  = self.GetCheckInfo("UNIT_SLAVE")
		self.iUSpwork = self.GetCheckInfo("UNIT_SPICE_WORKER")
		self.iUSabo   = self.GetCheckInfo("UNIT_SABOTEUR")
		self.iUWorm   = self.GetCheckInfo("UNIT_WORM1")
		self.iUHorn   = self.GetCheckInfo("UNITCOMBAT_HORNET")
		self.iUThop   = self.GetCheckInfo("UNITCOMBAT_THOPTER")
		self.iUMelee  = self.GetCheckInfo("UNITCOMBAT_MELEE")
		self.iUMentat = self.GetCheckInfo("UNIT_MENTAT")
		self.iUMonitor = self.GetCheckInfo("UNIT_MONITOR_WARSHIP")
		self.iUAtomic = self.GetCheckInfo("UNIT_ATOMIC_BOMB")
		self.iVTerra  = self.GetCheckInfo("VICTORY_TERRAFORMING")
		self.iVSpice  = self.GetCheckInfo("VICTORY_SPICE")
		self.dPlaySpice = {}
		self.dHomeCombats = {
			self.GetCheckInfo("UNITCOMBAT_GUARDSMAN") : 1,
			self.GetCheckInfo("UNITCOMBAT_SIEGE") : 1,
			self.GetCheckInfo("UNITCOMBAT_VEHICLE") : 1,
			self.GetCheckInfo("UNITCOMBAT_MECH") : 1,
			self.iUMelee : 1
		}	
		self.dFremenCapture = {
			self.GetCheckInfo("UNITCOMBAT_VEHICLE") : 1,
			self.GetCheckInfo("UNITCOMBAT_SUSPENSOR") : 1,
			self.GetCheckInfo("UNITCOMBAT_THOPTER") : 1
		}
		self.dWormUnits = {
			self.GetCheckInfo("UNIT_WORM1") : 1,
			self.GetCheckInfo("UNIT_WORM2") : 2,
			self.GetCheckInfo("UNIT_WORM3") : 3,
			self.GetCheckInfo("UNIT_WORM4") : 4
		}
		self.dFreshB = { self.iBLiet : 1, self.iBCatch : 1 }
		self.dKwisU = {
			self.GetCheckInfo("UNIT_KWISATZ_PRECURSOR") :
				self.GetCheckInfo("PROMOTION_INSPIRED1"),
			self.GetCheckInfo("UNIT_KWISATZ_ASPIRANT") :
				self.GetCheckInfo("PROMOTION_INSPIRED2"),
			self.GetCheckInfo("UNIT_KWISATZ_CANDIDATE") :
				self.GetCheckInfo("PROMOTION_INSPIRED3"),
			self.GetCheckInfo("UNIT_KWISATZ_HADERACH") :
				self.GetCheckInfo("PROMOTION_INSPIRED4")
		}
		self.lKwisP = [
			self.GetCheckInfo("PROMOTION_INSPIRED1"),
			self.GetCheckInfo("PROMOTION_INSPIRED2"),
			self.GetCheckInfo("PROMOTION_INSPIRED3"),
			self.GetCheckInfo("PROMOTION_INSPIRED4")
		]
		self.lPlagueCombats = [
			self.GetCheckInfo("UNITCOMBAT_GUARDSMAN"),
			self.GetCheckInfo("UNITCOMBAT_MELEE")
		]
		self.lMonitorProj = [
			self.GetCheckInfo("PROJECT_MONITOR_ELECTRICAL_SYSTEM"),
			self.GetCheckInfo("PROJECT_MONITOR_WEAPONS_SYSTEM"),
			self.GetCheckInfo("PROJECT_MONITOR_PROPULSION_SYSTEM"),
			self.GetCheckInfo("PROJECT_MONITOR_HULL"),
			self.GetCheckInfo("PROJECT_MONITOR_POWER_SYSTEM")
		]
		self.dSandU = {
			self.GetCheckInfo("UNIT_WORKER") : 0,
			self.GetCheckInfo("UNIT_SETTLER") : 0,
			self.GetCheckInfo("UNIT_WARRIOR") : 0,
			self.GetCheckInfo("UNIT_FREMEN_SCOUT") : 0,
			self.GetCheckInfo("UNIT_CRYSKNIFE_FIGHTER") : 1,
			self.GetCheckInfo("UNIT_NAIBS_CHOSEN") : 1,
			self.GetCheckInfo("UNIT_FEDAYKIN") : 1,
			self.GetCheckInfo("UNIT_SHAIHULUD_ADVOCATE") : 1,
			self.GetCheckInfo("UNIT_QIZARATE_ADVOCATE") : 1
		}
		self.lCureB = [
			self.GetCheckInfo("BUILDING_INFIRMARY"),
			self.GetCheckInfo("BUILDING_SUK_ACADEMY")
		]
		self.lMentatP = [
			self.GetCheckInfo("PROMOTION_MENTAT_CIVIC"),
			self.GetCheckInfo("PROMOTION_MENTAT_ESPIONAGE"),
			self.GetCheckInfo("PROMOTION_MENTAT_FINANCE"),
			self.GetCheckInfo("PROMOTION_MENTAT_INDUSTRY"),
			self.GetCheckInfo("PROMOTION_MENTAT_MILITARY")
		]
		self.lMentatB = []
		for iPromo in self.lMentatP:
			sPromo = gc.getPromotionInfo(iPromo).getType()
			sBldg = sPromo.replace("PROMOTION_", "BUILDING_")
			iBldg = self.GetCheckInfo(sBldg)
			self.lMentatB.append(iBldg)
			self.lMentatB.append(iBldg+1)
		self.dQueue = {}
		self.dContracts = {}
		self.iUpdateTimer = 0
		iSpeed = CyGame().getGameSpeedType()
		self.iSpeedPct = gc.getGameSpeedInfo(iSpeed).getImprovementPercent()
		self.dTerraformCount = {}
		self.bTerraformPop = false
		self.dSpiceVictoryCount = {}
		self.bSpiceVictoryPop = false
		# Set up for printing statistics
		# not for release: self.StatInit()

	# Display a transient message for a unit or improvement destroyed
	def DestroyPrint(self, pPlot, iPlay, sUnit, sName):
		if iPlay != -1:
			s = CyTranslator().getText("TXT_KEY_IMPROVEMENT_DESTROYED", (sUnit, sName))
			#s = "Un %s a detruit votre %s" % (sUnit, sName)
			CyInterface().addMessage(iPlay, True, 10, s, "",
				1, "", ColorTypes(8), -1, -1, True, True)
			
	# Storm or worm can damage improvement.  Return true if destroyed.
	def DamageImprovement(self, pPlot, sUnit, iPct):
		iType = pPlot.getImprovementType()
		if (iType != -1) and (iType != self.iIHut):
			if CyGame().getSorenRandNum(100, "stormdmg2") < iPct:
				sName = gc.getImprovementInfo(iType).getDescription()
				self.DestroyPrint(pPlot, pPlot.getOwner(), sUnit, sName)
				iType = gc.getImprovementInfo(iType).getImprovementPillage()
				pPlot.setImprovementType(iType)
				return true
		return false

	# Display a debug message regardless of player
	def GlobalMessage(self, txt):
		iPlay = gc.getActivePlayer().getID()
		CyInterface().addMessage(iPlay, True, 10, txt, "",
			1, "", ColorTypes(8), -1, -1, True, True)

	# If a slave is here, assume it was used, and destroy it.
	def RemoveSlave(self, pPlot):
		iPlay = pPlot.getOwner()
		for iUnit in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(iUnit)
			iOwner = pUnit.getOwner()
			if iOwner == iPlay:
				iType = pUnit.getUnitType()
				if iType == self.iUSlave:
					pUnit.kill(true, iOwner)
					return

	# Print a debug message to file
	def DebugPrint(self, txt):
		f = open(self.DebugFilename, "a")
		f.write(txt + "\n")
		f.close()

	# Remove spice in any adjacent plot
	def RemoveSpiceNearby(self, cx, cy, iRange):
		xmax = CyMap().getGridWidth()
		ymax = CyMap().getGridHeight()
		for ix in range(cx-iRange, cx+iRange+1):
			if (ix < 0) or (ix >= xmax): continue
			for iy in range(cy-iRange, cy+iRange+1):
				if (iy < 0) or (iy >= ymax): continue
				if (abs(ix-cx) + abs(iy-cy) >= iRange + 2) : continue
				#self.DebugPrint("Abs: %d Range: %s" % ((abs(ix-cx) + abs(iy-cy)), (iRange + 2)))
				pPlot = CyMap().plot(ix, iy)
				iType = pPlot.getFeatureType()
				if iType == self.iFSpice:
					pPlot.setFeatureType(-1, 0)
				if iType == self.iFBlow:
					pPlot.setFeatureType(-1, 0)
				iType = pPlot.getBonusType(TeamTypes.NO_TEAM)
				if iType == self.iBSpice:
					pPlot.setBonusType(-1)
				iType = pPlot.getTerrainType()				
				if iType == self.GetCheckInfo("TERRAIN_SPICE_OCEAN"):
					pPlot.setTerrainType(self.iTOcean, true, true)
				elif iType == self.GetCheckInfo("TERRAIN_SPICE_COAST"):
					pPlot.setTerrainType(self.iTCoast, true, true)
				iImpr = pPlot.getImprovementType()
				if iImpr == self.iIHarv:
					pPlot.setImprovementType(-1)

	def IsFresh(self, cx, cy):
		pMap = CyMap()
		pPlot = pMap.plot(cx, cy)
		if pPlot.isFreshWater(): return true
		return false

	# When Fremen unit is built, auto-add sandrider promotion
	def FremenPromotion(self, pUnit):
		bMatch = false
		iType = pUnit.getUnitType()
		iUcbt = pUnit.getUnitCombatType()
		pPlay = gc.getPlayer(pUnit.getOwner())
		iCiv = pPlay.getCivilizationType()
		if self.dSandU.has_key(iType) and iCiv != self.iCBarb:
			# Water debt units always get it
			if self.dSandU[iType] == 1: bMatch = true
			# Other units if correct civilization
			if iCiv == self.iCFrem: bMatch = true
		# Melee units if correct civilization
		if (iUcbt == self.iUMelee) and (iCiv == self.iCFrem):
			bMatch = true
		if bMatch:
			# ALN - remove sandworker first!
			# if pUnit.isHasPromotion(self.iPSandW):
				# pUnit.setHasPromotion(self.iPSandW, 0)
			# Add a sandrider and stillsuit promotion
			pUnit.setHasPromotion(self.iPSand, 1)

	# Tleilaxu in this plot; possibly spread plague, or remove if no war
	def SpreadPlague(self, pUnit):
		pPlot = pUnit.plot()
		bAlive = gc.getPlayer(self.iPTlei).isAlive()
		iTleiTeam = gc.getPlayer(self.iPTlei).getTeam()
		bHasValidAttempt = false
		iCounter = pPlot.getNumUnits()
		# Transmit
		while (not bHasValidAttempt and iCounter > 1):
			iSpreadRnd = CyGame().getSorenRandNum(pPlot.getNumUnits(),"spready")
			pUnit2 = pPlot.getUnit(iSpreadRnd)
			iPlay2 = pUnit2.getOwner()
			if (not iPlay2 == self.iPTlei): 
				pTeam2 = gc.getTeam(gc.getPlayer(iPlay2).getTeam())
				for i in self.lPlagueCombats:
					if ((pUnit2.getUnitCombatType() == i) and (not pUnit2.isHasPromotion(self.iPPlague))): 
						iRnd = CyGame().getSorenRandNum(100, "tleispread")
						bHasValidAttempt = true
						if iRnd < 40: # transmit percent
							pUnit2.setHasPromotion(self.iPPlague, 1)
							break
			iCounter = iCounter - 1
		# Clear Plague
		for iUnit2 in range(pPlot.getNumUnits()):
			pUnit2 = pPlot.getUnit(iUnit2)
			iPlay2 = pUnit2.getOwner()
			if iPlay2 == self.iPTlei: continue
			pTeam2 = gc.getTeam(gc.getPlayer(iPlay2).getTeam())
			if (not bAlive) or (not pTeam2.isAtWar(iTleiTeam)):
				pUnit2.setHasPromotion(self.iPPlague, 0)

	# If city has axlotl tank, clone best unit of same type
	def TleilaxuClone(self, pCity, pUnit):
		if pCity.getNumRealBuilding(self.iBAxlotl) == 0: return
		iExp = pUnit.getExperience()
		iBestExp = 0
		iType = pUnit.getUnitType()
		pPlay = gc.getPlayer(pUnit.getOwner())
		(pUnit2, iter) = pPlay.firstUnit(false)
		while (pUnit2):
			if pUnit2.getUnitType() == iType:
				iExp2 = pUnit2.getExperience()
				if (iExp2 > iBestExp) and (iExp2 > iExp):
					pBestUnit = pUnit2
					iBestExp = iExp2
			(pUnit2, iter) = pPlay.nextUnit(iter, false)
		if iBestExp == 0: return # no clone candidate found
		self.TleilaxuCopyPromos(pBestUnit, pUnit)
		pUnit.setExperience(iBestExp, -1)
		pUnit.setLevel(pBestUnit.getLevel())

	# For Tleilaxu cloning, copy promos to unit except maybe lose one
	def TleilaxuCopyPromos(self, pFromUnit, pToUnit):
		iPromoLost = -1
		if CyGame().getSorenRandNum(100, "") < 90:
			lMayLose = []
			for i in range(gc.getNumPromotionInfos()):
				if pFromUnit.isHasPromotion(i):
					s = gc.getPromotionInfo(i).getType()
					if s[-1].isdigit():
						# If promotion ends in digit, and unit has promotion with
						# next higher digit, this promotion cannot be lost
						t = s[:-1] + chr(ord(s[-1])+1) # COMBAT1 => COMBAT2
						p = gc.getInfoTypeForString(t)
						if p != -1 and pFromUnit.isHasPromotion(p): continue
					lMayLose.append(i)
			if lMayLose != []:
				posn = CyGame().getSorenRandNum(len(lMayLose), "tleicopy")
				iPromoLost = lMayLose[posn]
		# Copy the promotions except the lost one
		for i in range(gc.getNumPromotionInfos()):
			if i == iPromoLost: continue
			if pFromUnit.isHasPromotion(i):
				pToUnit.setHasPromotion(i, 1)

	# Create a new unit and copy info from the old one to it
	def Convert(self, pUnit, iNewType):
		ix = pUnit.getX() ; iy = pUnit.getY()
		iOwner = pUnit.getOwner()
		pOwner = gc.getPlayer(iOwner)
		dir = DirectionTypes(pUnit.getFacingDirection())
		try: # occasionally throws unrecognized C++ exception
		        pNew = pOwner.initUnit(iNewType, ix, iy, \
		        	UnitAITypes.NO_UNITAI, dir)
			pNew.convert(pUnit)
		except: pass # ... and ignore it

	# Queue a unit for deletion or change
	def Queue(self, pUnit, iNewType): self.dQueue[pUnit] = iNewType

	# Delete/change units; must not do this during AI update loop
	def Dequeue(self):
		for pUnit in self.dQueue.keys():
			iNewType = self.dQueue[pUnit]
			if iNewType != -1: self.Convert(pUnit, iNewType)
			else:
				try: # occasionally throws unrecognized C++ exception
					pUnit.kill(true, pUnit.getOwner())
				except:
					pass
		self.dQueue = {}

	# This should not need to be a function, but used to cause throw
	def OceanPlot(self):
		n = len(self.lOcean)
		iRnd = CyGame().getSorenRandNum(n, "pickocean")
		return self.lOcean[iRnd]
		
	# Display basic "OK" popup
	def BasicPopup (self, text):
		pPop = CyPopupInfo()
		pPop.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON)
		pPop.setText(text)
		pPop.addPythonButton("OK", "")
		pPop.addPopup(gc.getActivePlayer().getID())

	# Make a city name with a terrain specific suffix (by deliverator)
	def MakeCityName(self, pCity):
		pBarb = gc.getPlayer(gc.getBARBARIAN_PLAYER())
		iBarbCiv = pBarb.getCivilizationType()
		pInfo = gc.getCivilizationInfo(iBarbCiv)
		n = pInfo.getNumCityNames()
		i = CyGame().getSorenRandNum(n, "cityname")
		#Calvitix : changes for French Patch
		#hillsSuffixArray = ["Sink", "Basin", "Chasm", "Pan"]
		#nonHillsSuffixArray = ["Rock", "Pass", "Ridge", "Gap", "Lookout"]
		#exceptionsArray = ["Cliff", "Cave", "Windsack"]
		hillsSuffixArray = ["TXT_KEY_HILLS_SUFFIX_01", "TXT_KEY_HILLS_SUFFIX_02", "TXT_KEY_HILLS_SUFFIX_03", "TXT_KEY_HILLS_SUFFIX_04"]
		nonHillsSuffixArray = ["TXT_KEY_NONHILLS_SUFFIX_01", "TXT_KEY_NONHILLS_SUFFIX_02", "TXT_KEY_NONHILLS_SUFFIX_03", "TXT_KEY_NONHILLS_SUFFIX_04", "TXT_KEY_NONHILLS_SUFFIX_05"]
		exceptionsArray = ["TXT_KEY_EXCEPTION_SUFFIX_01", "TXT_KEY_EXCEPTION_SUFFIX_02", "TXT_KEY_EXCEPTION_SUFFIX_03"]
		#hillsSuffixArray = ["Vallee", "Bassin", "Gouffre", "Plateau"]
		#nonHillsSuffixArray = ["Rocher", "Passage", "Arete", "Breche", "Repaire"]
		#exceptionsArray = ["Falaise", "Caverne", "Pic"]
		baseCityName = pInfo.getCityNames(i)
		baseCityName = CyTranslator().getText(baseCityName, ("",))
		allSuffixArray = []
		allSuffixArray.extend(hillsSuffixArray)
		allSuffixArray.extend(nonHillsSuffixArray)
		allSuffixArray.extend(exceptionsArray)
		cityNameSuffix = ""
		bAppendTerrainSuffix = true
		for mySuffix in allSuffixArray:
			changedSuffix = CyTranslator().getText(mySuffix, ("",))
			if changedSuffix in baseCityName:
				bAppendTerrainSuffix = false
				break
		if bAppendTerrainSuffix == true:
			if pCity.plot().isHills():
				ihs = CyGame().getSorenRandNum(len(hillsSuffixArray) + 1, "hillsuffix")
				if ihs < len(hillsSuffixArray):
					#Calvitix : changes for French Patch
					cityNameSuffix = hillsSuffixArray[ihs]
					baseCityName = CyTranslator().getText(cityNameSuffix, (baseCityName,))
			else:
				ihs = CyGame().getSorenRandNum(len(nonHillsSuffixArray) + 1, "nonhillsuffix")
				if ihs < len(nonHillsSuffixArray):
					#Calvitix : changes for French Patch
					cityNameSuffix = nonHillsSuffixArray[ihs]
					baseCityName = CyTranslator().getText(cityNameSuffix, (baseCityName,))
		return baseCityName
		
	# Combat win, maybe capture slave (Harkonnen) or vehicle (Fremen).
	def CombatCapture(self, pLoseUnit, pWinPlay, pWinUnit, bSlave):
		iType = pLoseUnit.getUnitType()
		if self.dWormUnits.has_key(iType):
			return
		iCombat = pLoseUnit.getUnitCombatType()
		if not bSlave and not self.dFremenCapture.has_key(iCombat):
			return
		bCaptureSuccess = false
		if bSlave:
			if CyGame().getSorenRandNum(100, "cbtcapture") < 50:		
				iType = self.iUSlave
				txt = CyTranslator().getText("TXT_KEY_GET_SLAVE", ())
				btn = "Art/Interface/Buttons/Units/slave.dds"
				iDamage = 0
				bCaptureSuccess = true
		else:
			if CyGame().getSorenRandNum(100, "cbtcapture") < 20:				
				txt = CyTranslator().getText("TXT_KEY_GET_VEHICLE", ())
				btn = "Art/Interface/Buttons/Units/vehicle-cbt.dds"
				iDamage = 90
				bCaptureSuccess = true
		if bCaptureSuccess:	
			pNew = pWinPlay.initUnit(iType, pWinUnit.getX(),
				pWinUnit.getY(), UnitAITypes.NO_UNITAI,
				DirectionTypes.NO_DIRECTION)
			pNew.finishMoves()
			pNew.setDamage(iDamage, pWinPlay.getID()) 
			CyInterface().addMessage(pWinUnit.getOwner(), False,
				15, txt, '', 0, btn, ColorTypes(44),
				pWinUnit.getX(), pWinUnit.getY(), True, True)

	### END OF TURN ROUTINES

	# Count existing worms, storms, spice and unowned sandsea plots
	def Count(self):
		iUnowned = 0 ; iWormCount = 0 ; iSpiceCount = 0
		iMaxStr = 0
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			iType = pPlot.getBonusType(TeamTypes.NO_TEAM)
			if iType == self.iBSpice:
				iSpiceCount = iSpiceCount + 1
			iType = pPlot.getFeatureType()
			if iType == self.iFBlow:
				iSpiceCount = iSpiceCount + 8
			for iUnit in range (pPlot.getNumUnits()):
				pUnit = pPlot.getUnit(iUnit)
				iType = pUnit.getUnitType()
				if self.dWormUnits.has_key(iType):
					iWormCount = iWormCount + 1
				else:
					# Not a worm.  Keep max combat strength
					iStr = pUnit.baseCombatStr()
					if iStr > iMaxStr: iMaxStr = iStr
			if (not pPlot.isOwned()) and pPlot.isWormFriendly():
				iUnowned = iUnowned + 1
		return (iUnowned, iWormCount, iSpiceCount, iMaxStr)

	# Add new spice blows
	def BlowAdd(self, iSpiceCount, bImmediate):
		xmax = CyMap().getGridWidth() ; ymax = CyMap().getGridHeight ()
		# Compute the number of blows to be added
		iBlowWant = (xmax * ymax / 50) - (iSpiceCount / 8)
		if iBlowWant < 0: iBlowWant = 0
		# Add the blows at random locations
		for i in range(iBlowWant):
			for iTry in range(100):
				cx = CyGame().getSorenRandNum(xmax, "")
				cy = CyGame().getSorenRandNum(ymax, "")
				pPlot = CyMap().plot(cx, cy)
				if not pPlot.isWormFriendly(): continue
				if self.IsFresh(cx, cy): continue
				if bImmediate: self.SpiceAdd(cx, cy)
				else: pPlot.setFeatureType(self.iFBlow, 0)
				break

	# Add spice bonuses in radius after a blow
	def SpiceAdd(self, cx, cy):
		xmax = CyMap().getGridWidth() ; ymax = CyMap().getGridHeight ()
		for ix in range(cx-1, cx+2):
			if (ix < 0) or (ix >= xmax): continue
			for iy in range(cy-1, cy+2):
				if (iy < 0) or (iy >= ymax): continue
				pPlot = CyMap().plot(ix, iy)
				if not pPlot.isWormFriendly(): continue
				if self.IsFresh(ix, iy): continue
				iRnd = CyGame().getSorenRandNum(100, "spicetype")
				if iRnd < 80:
					pPlot.setBonusType(self.iBSpice)
					pPlot.setFeatureType(self.iFSpice, 0)
					iType = pPlot.getTerrainType()
					if iType == self.iTOcean:
						pPlot.setTerrainType(self.GetCheckInfo("TERRAIN_SPICE_OCEAN"), true, true)
					elif iType == self.iTCoast:
						pPlot.setTerrainType(self.GetCheckInfo("TERRAIN_SPICE_COAST"), true, true)

	# Loop all spiceblow features and give 25% chance to convert to spice
	def SpiceBlow(self):
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			if pPlot.getFeatureType() != self.iFBlow: continue
			if CyGame().getSorenRandNum(1000, "spicedecay") < 250:
				# Remove the feature and add spice bonuses
				pPlot.setFeatureType(-1, 0)
				self.SpiceAdd(pPlot.getX(), pPlot.getY())

	# Randomly remove spice, faster if it has a harvester, slower if
	# the owner follows the Spice Industry civic
	def SpiceDecay(self):
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			iType = pPlot.getBonusType(TeamTypes.NO_TEAM)
			if iType != self.iBSpice: continue
			iImpr = pPlot.getImprovementType()
			bSpind = false
			iPlay = pPlot.getOwner()
			if iPlay != -1:
				pPlay = gc.getPlayer(iPlay)
				if pPlay.getCivics(self.iCArrak) == self.iCSpind: bSpind = true
			if bSpind: iChance = 2
			elif iImpr == self.iIHarv: iChance = 20
			else: iChance = 5
			iChance = int (100.0 * iChance / self.iSpeedPct)
			if CyGame().getSorenRandNum(1000, "spicedecay") < iChance:
				pPlot.setFeatureType(-1, 0)
				pPlot.setBonusType(-1)
				iType = pPlot.getTerrainType()				
				if iType == self.GetCheckInfo("TERRAIN_SPICE_OCEAN"):
					pPlot.setTerrainType(self.iTOcean, true, true)
				elif iType == self.GetCheckInfo("TERRAIN_SPICE_COAST"):
					pPlot.setTerrainType(self.iTCoast, true, true)
				if iImpr == self.iIHarv:
					pPlot.setImprovementType(-1)

	# If Tleilaxu plague, unhealth cities or cure if hospital
	def PlagueCities(self):
		if self.iPTlei == -1: return
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			iCiv = pPlay.getCivilizationType()
			(pCity, iter) = pPlay.firstCity(false)
			while (pCity):
				if (not pCity.isNone()) and (pCity.getOwner() == iPlay):
					# Any cure buildings in city?
					bCure = false ; iPlagueBldg = 0
					for iBldg in self.lCureB:
						if pCity.getNumRealBuilding(iBldg) > 0:
							bCure = true
							break
					# Loop units and find plague, maybe cure
					pPlot = pCity.plot()
					for iUnit in range(pPlot.getNumUnits()):
						pUnit = pPlot.getUnit(iUnit)
						if bCure:
							pUnit.setHasPromotion(self.iPPlague, 0)
						elif pUnit.isHasPromotion(self.iPPlague):
							iPlagueBldg = 1
					pCity.setNumRealBuilding(self.iBPlague, iPlagueBldg)
				(pCity, iter) = pPlay.nextCity(iter, false)

	### UNIT LOOP ROUTINES

	# Loop the units by player and perform some operations
	def UnitLoop(self):
		(bAnyKH, dKwisatz) = self.FindKwisatz()
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			iCiv = pPlay.getCivilizationType()
			(pUnit, iter) = pPlay.firstUnit(false)
			while (pUnit):
				iUnitType = pUnit.getUnitType()
				if iUnitType == self.iUSabo:
					# self.SpyExperience(iCiv, pUnit)
					if iCiv == self.iCTlei:
						self.SpreadPlague(pUnit)
				self.HomeGround(pUnit, iPlay)
				if pUnit.isHasPromotion(self.iPPlague):
					self.SpreadPlague(pUnit)
				if iCiv == self.iCGess and bAnyKH:
					self.KwisatzInspire(pUnit, dKwisatz)
				(pUnit, iter) = pPlay.nextUnit(iter, false)

	# For any spy unit of the right civ, give it one more XP up to 100
	# def SpyExperience(self, iCiv, pUnit):
		# if iCiv != self.iCOrdos: return
		# ALN FracExp NextLine...
		# if pUnit.getExperienceInteger() >= 100: return
		# pUnit.changeExperience(1, 100, false, false, false)

	# For any ground unit, give/take Home Ground promotion if in/out of
	# its own cultural borders
	def HomeGround(self, pUnit, iPlay):
		iCombatType = pUnit.getUnitCombatType()
		n = 0
		if pUnit.plot().getOwner() == iPlay: n = 1
		if self.dHomeCombats.has_key(iCombatType):
			pUnit.setHasPromotion(self.iPHome, n)

	# Give/take inspiration promo for Kwisatz stacks.  The dictionary
	# has a key of x,y and the value is the promo of the highest
	# KH in the stack.
	def KwisatzInspire(self, pUnit, dKwisatz):
		pPlot = pUnit.plot()
		sxy = "%d,%d" % (pPlot.getX(), pPlot.getY())
		iType = pUnit.getUnitType()
		if dKwisatz.has_key(sxy) and (not self.dKwisU.has_key(iType)):
			iPromo = dKwisatz[sxy]
			pUnit.setHasPromotion(iPromo, 1)
		else:
			iPromo = -1
		for i in self.lKwisP:
			if iPromo == i: continue
			if pUnit.isHasPromotion(i):
				pUnit.setHasPromotion(i, 0)

	# Find any Kwisatz Haderachs and make a dictionary of their location
	def FindKwisatz(self):
		dKwisatz = {}
		bAnyKH = false
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			iCiv = pPlay.getCivilizationType()
			if iCiv != self.iCGess: continue
			(pUnit, iter) = pPlay.firstUnit(false)
			while (pUnit):
				iType = pUnit.getUnitType()
				if self.dKwisU.has_key(iType):
					iPromo = self.dKwisU[iType]
					p = pUnit.plot()
					sxy = "%d,%d" % (p.getX(), p.getY())
					if (not dKwisatz.has_key(sxy)) or dKwisatz[sxy] < iPromo:
						dKwisatz[sxy] = iPromo
						bAnyKH = true
				(pUnit, iter) = pPlay.nextUnit(iter, false)
		return (bAnyKH, dKwisatz)

	### TERRAFORMING ROUTINES

	# Terraforming for cities.  Count reservoirs for diplo penalty, and
	# remove catch/reservoir if nonmatching civic.  Return chance of
	# terraform upgrade for each player, based on number of reservoirs.
	def TerraformCity(self):
		lIndustry = [] ; lNeutral = [] ; dChances = {}
		# List players with and without spice industry civic
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			if pPlay.isHuman(): continue
			if pPlay.getCivics(self.iCArrak) == self.iCSpind:
				lIndustry.append(pPlay)
			else:
				lNeutral.append(pPlay)
		# Count reservoirs and remove catch/res + fresh if wrong civic
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			bHasParadise = false
			bHasSpiceCivic = false
			if pPlay.getCivics(self.iCArrak) == self.iCPara:
				bHasParadise = true
			elif pPlay.getCivics(self.iCArrak) == self.iCSpind:
				bHasSpiceCivic = true			
			iResCount = 0 ; iCatchCount = 0 ; iCities = 0
			(pCity, iter) = pPlay.firstCity(false)
			while (pCity):
				pPlot = pCity.plot()
				# ALN count cites
				iCities = iCities + 1
				# cx = pPlot.getX() ; cy = pPlot.getY()
				if pCity.getNumRealBuilding(self.iBCatch) > 0:
					if not bHasParadise:
						pCity.setNumRealBuilding(self.iBCatch, 0)
						pPlot.changeFreshWaterInRadius(-1, 2)	
					else:
						iCatchCount = iCatchCount + 1
				if pCity.getNumRealBuilding(self.iBLiet) > 0:
					if not bHasParadise:
						pCity.setNumRealBuilding(self.iBLiet, 0)
						pPlot.changeFreshWaterInRadius(-1, 3)	
					else:
						iResCount = iResCount + 1
				if pCity.getNumRealBuilding(self.iBSSilo) > 0:
					if not bHasSpiceCivic:
						pCity.setNumRealBuilding(self.iBSSilo, 0)			
				(pCity, iter) = pPlay.nextCity(iter, false)
			# Set reaction count of industry players to -2*rescount
			if len(lIndustry) > 0:
				iPen = -2 * iResCount
				if iPen < -8: iPen = -8
				for pPlay2 in lIndustry:
					pPlay2.AI_setAttitudeExtra(iPlay, iPen)
			if len(lNeutral) > 0:
				for pPlay2 in lNeutral:
					pPlay2.AI_setAttitudeExtra(iPlay, 0)
			# Set chance of terraform upgrade
			if bHasParadise:
				# ALN - put in some breaks on the system - lots of cities come at a cost
				iTargetCities = gc.getWorldInfo(gc.getMap().getWorldSize()).getTargetNumCities()
				iCities = max(0, iCities - iTargetCities)
				dChances[iPlay] = 10 + max(0, (2 * iCatchCount) + (5 * iResCount) - (2 * iCities))
		return dChances	
		
	# This plot does not qualify for terraforming.  If terraformed,
	# high chance to undo back to base terrain.  Kill oasis.  Grass
	# to plains.  In sinks, plains to graben, else plains to rock.
	def TerraformDown(self, pPlot):
		if pPlot.getFeatureType() == self.iFOasis:
			pPlot.setFeatureType(-1, 0)
		iType = pPlot.getTerrainType()
		if iType == self.iTTGrass:
			iNew = self.iTTPlain
		elif iType == self.iTTPlain:
			if pPlot.isHills(): iNew = self.iTGrab
			else: iNew = self.iTRock
		else: return
		if CyGame().getSorenRandNum(100, "ungreen") < 50: return
		pPlot.setTerrainType(iNew, true, true)

	# This plot qualifies for terraforming.  Salt to graben to plains;
	# badland or rugged to rock; rock to plains; plains to grass.
	def TerraformUp(self, pPlot, dChances):
		iChance = dChances[pPlot.getOwner()]
		iChance = int (100.0 * iChance / self.iSpeedPct)
		# ALN - Base the chances of terraforming on world size to compensate for more or less cities
		iTotalOdds = gc.getWorldInfo(gc.getMap().getWorldSize()).getTargetNumCities() * 200
		iType = pPlot.getTerrainType()
		if iType == self.iTSalt: iNew = self.iTGrab
		elif iType == self.iTGrab: iNew = self.iTTPlain
		elif iType == self.iTRug:
			iNew = self.iTRock
			iChance = iChance / 2
		elif iType == self.iTRock: iNew = self.iTTPlain
		elif iType == self.iTTPlain: iNew = self.iTTGrass
		elif iType == self.iTPolar: iNew = self.iTTGrass
		elif iType == self.iTTGrass:
			# Possible oasis, if none nearby
			if pPlot.getFeatureType() != -1: return
			if pPlot.getBonusType(TeamTypes.NO_TEAM) != -1: return
			if not pPlot.isHills(): return
			if CyGame().getSorenRandNum((iTotalOdds * 3 / 2), "putlake") >= iChance: return					
			#if CyGame().getSorenRandNum(100, "forest") < 50:	
			pPlot.setFeatureType(self.iFForest, 0)		
			return
			# Removed Open Water placement for now - Deliverator
			#else:
			#	xmax = CyMap().getGridWidth()
			#	ymax = CyMap().getGridHeight ()
			#	cx = pPlot.getX(); cy = pPlot.getY()
			#	for ix in range(cx-1, cx+2):
			#		if (ix < 0) or (ix >= xmax): continue
			#		for iy in range(cy-1, cy+2):
			#			if (iy < 0) or (iy >= ymax): continue
			#			iType = CyMap().plot(ix, iy).getFeatureType()
			#			if iType == self.iFOasis: return
			#	pPlot.setFeatureType(self.iFOasis, 0)	
			#	return
		else: return
		if CyGame().getSorenRandNum(iTotalOdds, "green") >= iChance: return
		pPlot.setTerrainType(iNew, true, true)

	# Main routine for terraforming victory called each turn.
	# If catchbasin/reservoir of liet exists but player does not
	#    have civic, destroy it.
	# Turn plots on fresh water, with paradise civic greener
	# If a terraformed plot is not on fresh with paradise, ungreen it
	def Terraform(self):
		map = CyMap()
		dChances = self.TerraformCity()
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			if pPlot.isWater() or pPlot.isPeak(): continue
			bUp = false
			iPlay = pPlot.getOwner()
			if dChances.has_key(iPlay) and pPlot.isFreshWater():
				pPlay = gc.getPlayer(iPlay)
				if pPlay.getCivics(self.iCArrak) == self.iCPara:
					bUp = true
			if bUp: self.TerraformUp(pPlot, dChances)
			else: self.TerraformDown(pPlot)

	### WORM ROUTINES

	# Add new worms
	def WormAdd(self, iUnowned, iWormCount, iMaxStr):
		pBarb  = gc.getPlayer(gc.getBARBARIAN_PLAYER())
		xmax = CyMap().getGridWidth() ; ymax = CyMap().getGridHeight ()
		# Compute the number of worms to be added
		pHandi = gc.getHandicapInfo(CyGame().getHandicapType())
		iUTPGA = pHandi.getUnownedTilesPerGameAnimal()
		iWormWant = (iUnowned / (3 * iUTPGA)) - iWormCount
		if iWormWant < 0: iWormWant = 0
		# Compute the strength of the worm to be added
		iWormStr = ((iMaxStr + 10) // 20) + 1
		if iWormStr < 1: iWormStr = 1
		if iWormStr > 4: iWormStr = 4
		iWormUnit = self.GetCheckInfo("UNIT_WORM%d" % iWormStr)
		if iWormUnit > self.iUWorm: self.iUWorm = iWormUnit
		# Add the worms at random locations
		for i in range(iWormWant):
			for iTry in range(100):
				pPlot = self.OceanPlot()
				if pPlot.isOwned(): continue
				pBarb.initUnit(iWormUnit, pPlot.getX(), pPlot.getY(),
					UnitAITypes.NO_UNITAI,
					DirectionTypes.DIRECTION_EAST)
				break

	# Is there a unit here which the worm can attack? 0:no 1:yes 2:mmm!
	def WormFood(self, cx, cy):
		bFound = false
		pPlot = CyMap().plot(cx, cy)
		for iUnit in range(pPlot.getNumUnits()):
			pUnit = pPlot.getUnit(iUnit)
			if pUnit.isHasPromotion(self.iPThump): return 2
			iType = pUnit.getUnitType()
			if self.dWormUnits.has_key(iType): continue
			iType = pUnit.getUnitCombatType()
			if iType == self.iUThop: continue
			if iType == self.iUHorn: continue
			if pUnit.isBarbarian(): continue
			bFound = true
		if bFound: return 1
		return 0

	# Main AI for worm movement
	def WormAI(self, pUnit):
		cx = pUnit.getX() ; cy = pUnit.getY()
		xmax = CyMap().getGridWidth() ; ymax = CyMap().getGridHeight ()
		pPlot = pUnit.plot()
		# delete UnitAITypes.NO_UNITAI units
		if (pUnit.getUnitAIType() == UnitAITypes.NO_UNITAI):
			self.Queue(pUnit, -1)	
			pUnit.finishMoves()
			return true			
		if self.DamageImprovement(pPlot, "sandworm", 100):
			# fortify after destroying improvement - flag for deletion using UnitAITypes.NO_UNITAI
			pGroup = pUnit.getGroup()
			pGroup.clearMissionQueue()
			pUnit.setUnitAIType(UnitAITypes.NO_UNITAI)
			pGroup.setActivityType(ActivityTypes.ACTIVITY_SLEEP)
			pUnit.NotifyEntity(MissionTypes.MISSION_FORTIFY)		
			pUnit.finishMoves()
			return true
		# 1.6.5: randomly kill some; may be stuck near a city
		if CyGame().getSorenRandNum(1000, "wormdie") < 30:
			self.Queue(pUnit, -1)
			pUnit.finishMoves()
			return true
		# Find a nearby target to move towards
		lCands = [] ; lThumps = [] ; lOpens = []
		for ix in range(cx-2, cx+3):
			if (ix < 0) or (ix >= xmax): continue
			for iy in range(cy-2, cy+3):
				if (iy < 0) or (iy >= ymax): continue
				if (cx == ix) and (cy == iy): continue
				pPlot = CyMap().plot(ix, iy)
				if not pPlot.isWormFriendly(): continue
				if self.IsFresh(ix, iy): continue
				iFood = self.WormFood(ix, iy)
				if iFood == 2: 
					if (abs(cx - ix) == 1) and (abs(cy - iy) == 1):
						self.Queue(pUnit, -1)
						pUnit.finishMoves()
						return true
					lThumps.append([ix,iy])
				elif iFood == 1: lCands.append([ix,iy])
				else:
					# Improvement
					iImpr = pPlot.getImprovementType()
					if (iImpr != -1) and (iImpr != self.iIHut):
						lCands.append ([ix, iy])
						continue
					# Open adjacent plot
					if abs(cx - ix) == 2: continue
					if abs(cy - iy) == 2: continue
					lOpens.append ([ix,iy])
		# Pick highest priority target and move towards it
		if lThumps != []: l = lThumps
		elif lCands != []: l = lCands
		elif lOpens != []: l = lOpens
		else: return false # we could not find anywhere to move
		iRnd = CyGame().getSorenRandNum(len(l), "wormai")
		(ix, iy) = l[iRnd]
		try: # occasionally throws unrecognized C++ exception
			pGroup = pUnit.getGroup()
			pGroup.clearMissionQueue()
			pGroup.pushMoveToMission(ix, iy)
			pUnit.finishMoves()
			return true
		except:
			pass
		return false

	### STORM ROUTINES

	# Parse scriptdata of 0,0: convert x1,y1,t;x2,y2,t; ... into list of triples
	def StormList(self):
		lStorms = []
		s = CyMap().plot(0,0).getScriptData()
		if s != "":
			for lxyt in s.split(";"):
				(ix, iy, type) = lxyt.split(",")
				lStorms.append([int(ix),int(iy), int(type)])
		return lStorms

	# Draw storm effects, called by CvMainInterface::redraw
	def StormDraw(self):
		self.Initialize()
		self.iUpdateTimer += 1
		if self.iUpdateTimer == 12:
			self.iUpdateTimer = 0
			for lxyt in self.StormList():
				(ix, iy, iType) = lxyt
				pPoint = CyMap().plot(ix, iy).getPoint()
				if iType == 1:
					pPlot = CyMap().plot(ix, iy)
					iPlotType = pPlot.getTerrainType()
					if CyMap().plot(ix, iy).isWater() or iPlotType == self.iTDunes: iEffect = self.iESandD
					else: iEffect = self.iESandL
				else: iEffect = self.iESand # should be rain
				CyEngine().triggerEffect(iEffect, pPoint)

	# Top level storm routine: add/subtract, die, do damage, and move
	def StormRun(self):
		lOldStorms = self.StormAddSubtract()
		sNewStorms = ""
		for lxyt in lOldStorms:
			(ix, iy, type) = lxyt
			pPlot = CyMap().plot(ix, iy)
			pPlot.setSandstorm(false)			
			if not self.StormDie(ix, iy):
				self.StormDamage(ix, iy)
				(nx, ny) = self.StormMove(ix, iy)
				if nx != -1:
					sNewStorms += (";%d,%d,1" % (nx, ny))
					pPlot = CyMap().plot(nx, ny)
					pPlot.setSandstorm(true)
					BugUtil.debug("Sandstorm at %d %d", nx, ny)
		CyMap().plot(0,0).setScriptData(sNewStorms[1:])

	# Add new storms, then delete any which are adjacent
	def StormAddSubtract(self):
		lStorms = self.StormList()
		# Compute the number of storms to be added
		iStormWant = (len(self.lOcean) / 25) - len(lStorms)
		if iStormWant < 0: iStormWant = 0
		# Add the storms at random locations
		for i in range(iStormWant):
			for iTry in range(100):
				pPlot = self.OceanPlot()
				if pPlot.isOwned(): continue
				lStorms.append([pPlot.getX(), pPlot.getY(), 1])
				break
		# Loop the list and delete one of an adjacent pair
		n = len(lStorms)
		lDeletes = []
		for i in range(n-1):
			(ix, iy, type) = lStorms[i]
			for j in range(i+1, n):
				(jx, jy, type) = lStorms[j]
				if abs (ix - jx) > 2: continue
				if abs (iy - jy) > 2: continue
				# Tag the i position for deletion and skip to next i
				lDeletes.append(i)
				break
		# To keep indices valid, reverse list (now largest to smallest)
		if lDeletes != []:
			lDeletes.reverse()
			for i in lDeletes: del lStorms[i]
		return lStorms

	# Do damage for storm
	def StormDamage(self, cx, cy):
		pPlot = CyMap().plot(cx, cy)
		iPct = 50
		if pPlot.isHills(): iPct = 10
		elif pPlot.isPeak(): iPct = 1
		elif pPlot.getTerrainType() == self.iTOcean: iPct = 90
		# Improvement
		self.DamageImprovement(pPlot, "sandstorm", iPct)
		# Units
		for iU in range (pPlot.getNumUnits()):
			pVictim = pPlot.getUnit(iU)
			iType = pVictim.getUnitType()
			iRnd = CyGame().getSorenRandNum(100, "stormdmg3")
			if self.dWormUnits.has_key(iType): continue
			if iRnd < iPct:
				iDam = pVictim.getDamage()
				iRnd2 = CyGame().getSorenRandNum(100, "stormdmg4")
				iUnitCombat = pVictim.getUnitCombatType()
				iKillChance = 50
				if (iUnitCombat == self.iUThop):
					iKillChance = 90
				if (iRnd2 < iKillChance) or (iDam > 75): # kill it
					sName = gc.getUnitInfo(iType).getDescription()
					self.DestroyPrint(pPlot, pVictim.getOwner(), "sandstorm", sName)
					self.Queue(pVictim, -1)
				else:
					iNewDam = iDam + 50
					if iNewDam > 90: iNewDam = 90
					pVictim.setDamage(iNewDam, gc.getBARBARIAN_PLAYER())

	# Possibly kill storm on hill or peak, or due to weather satellite
	def StormDie(self, cx, cy):
		pPlot = CyMap().plot(cx, cy)
		iPlay = pPlot.getOwner()
		if (iPlay != -1) and (gc.getPlayer(iPlay).getBuildingClassCount(self.iBWCSat) > 0):
			return true
		iType = pPlot.getTerrainType()
		iRnd = CyGame().getSorenRandNum(100, "stormsize")
		if pPlot.isHills():
			if iRnd < 80: return true
		elif pPlot.isPeak(): return true
		elif iType == self.iTPCoast: return true
		elif iType == self.iTOcean: return false
		elif iRnd < 10: return true
		return false

	# Move one square east, possibly N/S; wrap, but die at pole
	def StormMove(self, cx, cy):
		xmax = CyMap().getGridWidth() ; ymax = CyMap().getGridHeight ()
		xchange = 0
		ychange = 0
		probxzero = 0
		probyzero = 0
		if cx < (xmax / 2):
			if cy < (ymax / 2):
				xchange = 1
				ychange = -1
				probxzero = 15
				probyzero = 35
			else:
				xchange = -1
				ychange = -1
				probxzero = 35
				probyzero = 15
		else:
			if cy < (ymax / 2):
				xchange = 1
				ychange = 1
				probxzero = 35
				probyzero = 15
			else:
				xchange = -1
				ychange = 1
				probxzero = 15
				probyzero = 35
		iRnd = CyGame().getSorenRandNum(100, "stormdrifty")
		if iRnd < probxzero:
			xchange = 0
		elif iRnd < (probxzero + probyzero):
			ychange = 0
		cx = cx + xchange
		cy = cy + ychange
		if cx == xmax or cx == -1 or cy == ymax or cy == -1: return (-1, -1)
		return (cx, cy)

	### TRADE CONTRACTS

	# At game start, setup the array of acceptable contracts.  If the
	# owning civ is in the game, mark the player number.  If any civ may
	# build it, mark -1.  If it is already built, mark -2.
	def ContractStart(self):
		self.dContracts = {
			self.iBWine : -1, self.iBIxWeap : -1, self.iBSardau : -1,
			self.iBOpaf : -1, self.iBKind : -1,
			self.iBSlig : -1, self.iBSoo : -1, self.iBPundi : -1,
			self.iBLabor : -1, self.iBSapho : -1
		}
		# Set value to player ID for owning civ, if in the game
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			iCiv = gc.getPlayer(iPlay).getCivilizationType()
			# Only this player may have this bonus
			# Don't forget to update SevoPediaBonus.py help
			if iCiv == self.iCCorr:
				self.dContracts[self.iBSardau] = iPlay
			elif iCiv == self.iCIx:
				self.dContracts[self.iBIxWeap] = iPlay
			elif iCiv == self.iCAtre:
				self.dContracts[self.iBWine] = iPlay
		# Set value to -2 if building exists anywhere
		lKeys = self.dContracts.keys()
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			(pCity, iter) = pPlay.firstCity(false)
			while (pCity):
				for iKey in lKeys:
					if pCity.getNumRealBuilding(iKey) > 0:
						self.dContracts[iKey] = -2
				(pCity, iter) = pPlay.nextCity(iter, false)

	# Can this player build this contract?  Check if contract array is
	# -1 (anybody can build) or matching player number.
	def ContractCan(self, argsList, sType):
		self.Initialize()
		if self.dContracts == {}: self.ContractStart()
		oTrigger = argsList[1]
		iPlayer = oTrigger.ePlayer
		pPlayer = gc.getPlayer(iPlayer)
		iKey = self.GetCheckInfo("BUILDING_" + sType + "_CONTRACT")
		if not self.dContracts.has_key(iKey): return false
		# Force civs to have to build their unique resource contract on second landing stage if not already built
		
		iCiv = gc.getPlayer(iPlayer).getCivilizationType()
		if iCiv == self.iCAtre:
			if self.countPlayerBuildings(iPlayer, self.iBStage) == 2 and self.countPlayerBuildings(iPlayer, self.iBWine) == 0 and not iKey == self.iBWine:
				return false
		elif iCiv == self.iCIx:
			if self.countPlayerBuildings(iPlayer, self.iBStage) == 2 and self.countPlayerBuildings(iPlayer, self.iBIxWeap) == 0 and not iKey == self.iBIxWeap:
				return false
		elif iCiv == self.iCCorr:
			if self.countPlayerBuildings(iPlayer, self.iBStage) == 2 and self.countPlayerBuildings(iPlayer, self.iBSardau) == 0 and not iKey == self.iBSardau:
				return false

		if self.dContracts[iKey] == -1: return true
		if self.dContracts[iKey] == -3: return true
		if self.dContracts[iKey] == iPlayer: return true
		return false

	def countPlayerBuildings (self, iPlay, iBuilding):
		pPlay = gc.getPlayer(iPlay)
		(pCity, iter) = pPlay.firstCity(false)
		iBCount = 0
		while (pCity):
			iBCount += pCity.getNumRealBuilding(iBuilding)
			(pCity, iter) = pPlay.nextCity(iter, false)	
		return iBCount
		
	# This player has built this contract; mark it built.
	def ContractDo(self, argsList, sType):
		self.Initialize()
		if self.dContracts == {}: self.ContractStart()
		iKey = self.GetCheckInfo("BUILDING_" + sType + "_CONTRACT")
		if not self.dContracts.has_key(iKey): return false
		if self.dContracts[iKey] != -3:
			self.dContracts[iKey] = -2

	# Help string for this contract
	def ContractHelp(self, argsList, sType):
		self.Initialize()
		if self.dContracts == {}: self.ContractStart()
		iPlay = gc.getActivePlayer().getID()
		iCiv = gc.getPlayer(iPlay).getCivilizationType()
		iKey = self.GetCheckInfo("BUILDING_" + sType + "_CONTRACT")
		s = gc.getBuildingInfo(iKey).getHelp()
		t = CyTranslator().getText("[ICON_BULLET]", ())
		if iKey == self.iBSemu:
			st2 = CyTranslator().getText("TXT_KEY_SEMUTA_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif iKey == self.iBSlig:
			st2 = CyTranslator().getText("TXT_KEY_SLIG_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif iKey == self.iBWine:
			st2 = CyTranslator().getText("TXT_KEY_CALWINE_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif (iKey == self.iBOpaf) or (iKey == self.iBSoo):
			st2 = CyTranslator().getText("TXT_KEY_OPAFIRE_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif iKey == self.iBPundi:
			st2 = CyTranslator().getText("TXT_KEY_PUNDI_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif iKey == self.iBKind:
			st2 = CyTranslator().getText("TXT_KEY_GINAZ_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		elif iKey == self.iBSardau:
			st2 = CyTranslator().getText("TXT_KEY_SARDAUKAR_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
			if iCiv == self.iCCorr:
				st2 = CyTranslator().getText("TXT_KEY_CORRINO_CONTRACT_STRATEGY", ())		
				s = t + st2 + "\n" + s
		elif iKey == self.iBIxWeap:
			st2 = CyTranslator().getText("TXT_KEY_IX_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
			if iCiv == self.iCIx:
				st2 = CyTranslator().getText("TXT_KEY_IXRECOM_CONTRACT_STRATEGY", ())		
				s = t + st2 + "\n" + s
		elif iKey == self.iBLabor:
			st2 = CyTranslator().getText("TXT_KEY_LABOR_CONTRACT_STRATEGY", ())
			s = t + st2 + "\n" + s
		return s

	### STATISTIC PRINTING

	# Entry point for printing statistics
	def StatPrint(self, iTurn):
		if (iTurn % 10) != 0: return
		# sTime = time.strftime("%H:%M:%S")
		# self.DebugPrint("Turn: %d Time: %s" % (iTurn, sTime))
		# return
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			# Economic details
			s = self.StatCommercePlayer(pPlay, iTurn)
			self.DebugPrint(s)

	# Return a string of commerce stats for this player
	def StatCommercePlayer(self, pPlay, iTurn):
		iNumCities = pPlay.getNumCities()
		iYield = YieldTypes.YIELD_COMMERCE
		iCommerce = 0 ; iTotalPop = 0
		iWorkedTileCount = 0 ; iWorkedTiles = 0
		iDomesticTrade = 0 ; iForeignTrade = 0
		iSpecialists = 0 ; iProduction = 0
		iResearch = 0 ; iNumTechs = 0
		for iCity in range(iNumCities):
			pCity = pPlay.getCity(iCity)
			iTotalPop += pCity.getPopulation()
			eTeam = pCity.getTeam()
			# Count worked tiles, sum commerce
			if not pCity.isDisorder():
				for i in range(gc.getNUM_CITY_PLOTS()):
					pPlot = pCity.getCityIndexPlot(i)
					if pPlot and not pPlot.isNone() and pPlot.hasYield():
						if pCity.isWorkingPlot(pPlot):
							iWorkedTileCount += 1
							iWorkedTiles += pPlot.getYield(iYield)
			# Sum domestic and foreign trade
			for i in range(pCity.getTradeRoutes()):
				tradeCity = pCity.getTradeCity(i)
				if tradeCity and tradeCity.getOwner() >= 0:
					iTrade = pCity.calculateTradeYield(iYield, \
							pCity.calculateTradeProfit(tradeCity))
					if tradeCity.getTeam() == eTeam:
						iDomesticTrade += iTrade
					else: iForeignTrade += iTrade

			# Specialist commerce
			if not pCity.isDisorder():
				for eSpec in range(gc.getNumSpecialistInfos()):
					iNumSpec = pCity.getSpecialistCount(eSpec) + \
						pCity.getFreeSpecialistCount(eSpec)
					iSpecialists += pPlay.specialistYield(eSpec, iYield) * iNumSpec

		# Buildings, by subtraction
		iTotalCommerce = pPlay.calculateTotalYield(iYield)
		iOtherCommerce = iWorkedTiles
		iOtherCommerce += iDomesticTrade + iForeignTrade
		iOtherCommerce += iSpecialists
		iBuildings = iTotalCommerce - iOtherCommerce

		# Production and research
		(pCity, iter) = pPlay.firstCity(false)
		while (pCity):
			if (not pCity.isNone()) and (pCity.getOwner() == pPlay.getID()):
				if not pCity.isDisorder():
					iProduction += pCity.getYieldRate(YieldTypes.YIELD_PRODUCTION)
					iResearch += pCity.getCommerceRate(CommerceTypes.COMMERCE_RESEARCH)
			(pCity, iter) = pPlay.nextCity(iter, false)
		pTeam = gc.getTeam(pPlay.getTeam())
		for iTech in range(gc.getNumTechInfos()):
			if pTeam.isHasTech(iTech): iNumTechs += 1

		# Score components (copied from CvGameUtils.calculateScore)
		iPopScore = CvUtil.getScoreComponent(pPlay.getPopScore(), gc.getGame().getInitPopulation(), gc.getGame().getMaxPopulation(), gc.getDefineINT("SCORE_POPULATION_FACTOR"), True, false, false)
		iLandScore = CvUtil.getScoreComponent(pPlay.getLandScore(), gc.getGame().getInitLand(), gc.getGame().getMaxLand(), gc.getDefineINT("SCORE_LAND_FACTOR"), True, false, false)
		iTechScore = CvUtil.getScoreComponent(pPlay.getTechScore(), gc.getGame().getInitTech(), gc.getGame().getMaxTech(), gc.getDefineINT("SCORE_TECH_FACTOR"), True, false, false)
		iWondersScore = CvUtil.getScoreComponent(pPlay.getWondersScore(), gc.getGame().getInitWonders(), gc.getGame().getMaxWonders(), gc.getDefineINT("SCORE_WONDER_FACTOR"), False, false, false)
		iScore = iPopScore + iLandScore + iTechScore + iWondersScore

		s = "%d,%s" % (iTurn,pPlay.getCivilizationShortDescriptionKey())
		return "%s,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d" % \
			(s, iWorkedTileCount, iWorkedTiles, iDomesticTrade, \
			iForeignTrade, iSpecialists, \
			iBuildings, iTotalCommerce, iNumCities, iTotalPop, \
			iProduction, iResearch, iNumTechs, iPopScore, \
			iLandScore, iTechScore, iWondersScore, iScore)

	# Set up to print stats
	def StatInit(self):
		# Header for econ stats
		self.DebugPrint("Turn,Player,NumTiles,Tiles,Dom,For,Spec,Bldg,Comm,Cities,Pop,Prod,Res,Techs,SPop,SLand,STech,SWond,STot")

	### MENTAT FUNCTIONS

	# Mentat unit built; pick specialty
	def MentatBuilt(self, pUnit):
		# Never starts with experience
		pUnit.setExperience(0, -1)
		# Trigger event to allow selecting specialty
		pPlay = gc.getPlayer(pUnit.getOwner())
		pPlay.initTriggeredData(self.iEMentat, true, 
			-1, pUnit.getX(), pUnit.getY(), -1,
			-1, -1, -1, pUnit.getID(), -1)

	# Event action function for mentat specialty
	def MentatDo(self, argsList, sType):
		iEvent = argsList[0]
		pData = argsList[1]
		self.Initialize()
		pPlay = gc.getPlayer(pData.ePlayer)
		pUnit = pPlay.getUnit(pData.iUnitId)
		iPromo = self.GetCheckInfo("PROMOTION_MENTAT_" + sType)
		pUnit.setHasPromotion(iPromo, 1)

	# Event help function for mentat specialty
	def MentatHelp(self, argsList, sType):
		self.Initialize()
		sPromo = "PROMOTION_MENTAT_" + sType
		iPromo = self.GetCheckInfo(sPromo)
		return gc.getPromotionInfo(iPromo).getHelp()

	# Return building for mentat promotion; cached in scriptdata
	def MentatGetBuilding(self, pUnit):
		self.Initialize()
		s = pUnit.getScriptData()
		if s != "": return int(s)
		# Not cached; find promotion
		iPromoHas = -1
		for iPromo in self.lMentatP:
			if pUnit.isHasPromotion(iPromo):
				iPromoHas = iPromo
				break
		if iPromoHas == -1: return -1 # Does not have any promo
		# Convert iPromo to iBldg, cache and return
		sBldg = gc.getPromotionInfo(iPromoHas).getType()
		sBldg = sBldg.replace("PROMOTION_", "BUILDING_")
		iBldg = self.GetCheckInfo(sBldg)
		pUnit.setScriptData("%d" % iBldg)
		return iBldg

	# Check cities for proper mentat building
	def MentatCities(self):
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			if not pPlay.isAlive(): continue
			(pCity, iter) = pPlay.firstCity(false)
			while (pCity):
				if (not pCity.isNone()) and (pCity.getOwner() == iPlay):
					pMentat = -1
					pPlot = pCity.plot()
					for iUnit in range(pPlot.getNumUnits()):
						pUnit = pPlot.getUnit(iUnit)
						if pUnit.getUnitType() != self.iUMentat: continue
						if pUnit.getOwner() != iPlay: continue
						pMentat = pUnit
					if pMentat != -1:
						self.MentatBuilding(pMentat, pCity)
					elif pCity.getScriptData() != "":
						# Delete previous building
						iBldg = int(pCity.getScriptData())
						pCity.setNumRealBuilding(iBldg, 0)
						pCity.setScriptData("")
				(pCity, iter) = pPlay.nextCity(iter, false)

	# Put proper building for this mentat
	def MentatBuilding(self, pUnit, pCity):
		iBldg = self.MentatGetBuilding(pUnit)
		if iBldg == -1: return # Does not have any promo
		if pCity.getNumBonuses(self.iBonusSapho) > 0: iBldg = iBldg + 1
		if pCity.getScriptData() != "":
			iCurrBldg = int(pCity.getScriptData())
			if iCurrBldg == iBldg: return
			pCity.setNumRealBuilding(iCurrBldg, 0)
		pCity.setNumRealBuilding(iBldg, 1)
		pCity.setScriptData("%d" % iBldg)

	# Utility: how many of my mentats in this plot?
	def MentatCount(self, pPlot, iPlay):
		iMentats = 0
		for iUnit in range(pPlot.getNumUnits()):
			pUnit2 = pPlot.getUnit(iUnit)
			iOwner = pUnit2.getOwner()
			if iOwner != iPlay: continue
			if pUnit2.getUnitType() == self.iUMentat:
				iMentats += 1
				if iMentats > 1: break # 2 == infinity
		return iMentats

	# AI movement entry point
	def MentatAI(self, pUnit):
		pPlot = pUnit.plot()
		iPlay = pUnit.getOwner()
		pPlay = gc.getPlayer(iPlay)
		if pPlot.isCity() and (self.MentatCount(pPlot, iPlay) == 1):
			# By myself, in city.  Stay here.
			pUnit.finishMoves()
			return true
		# Multiple mentats in city, or else not in city.
		# Find nearest city with no mentat and go there.
		bestDist = 1000000
		mx = pUnit.getX() ; my = pUnit.getY()
		(pCity, iter) = pPlay.firstCity(false)
		while (pCity):
			cx = pCity.getX() ; cy = pCity.getY()
			dx = abs (cx - mx) ; dy = abs (cy - my)
			if dy < dx: dx = dy
			if dx < bestDist:
				if self.MentatCount(pCity.plot(), iPlay) == 0:
					bestX = cx ; bestY = cy ; bestDist = dx
			(pCity, iter) = pPlay.nextCity(iter, false)
		if bestDist == 1000000:
			# no useful city to move to
			return false
		pGroup = pUnit.getGroup()
		pGroup.clearMissionQueue()
		pGroup.pushMoveToMission(bestX, bestY)
		pUnit.finishMoves()
		return true

	### TERRAFORMING VICTORY FUNCTIONS

	# Return the number of terraformed plots needed for a victory
	def TerraVictoryPlots(self):
		self.Initialize()
		xmax = CyMap().getGridWidth()
		ymax = CyMap().getGridHeight ()
		return int (xmax * ymax / 33)

	# Return cached count of terraformed plots for this player
	def TerraVictoryPlayer(self, iPlay):
		self.Initialize()
		if not self.dTerraformCount.has_key(iPlay): return 0
		return self.dTerraformCount[iPlay]

	# Check for victory by three percent of land terraformed
	# Update cached count of terraformed plots for this player
	def TerraVictoryCheck(self):
		self.Initialize()
		if not CyGame().isVictoryValid(self.iVTerra): return
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			self.dTerraformCount[iPlay] = 0
		for iPlotLoop in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(iPlotLoop)
			if pPlot.getTerrainType() != self.iTTGrass: continue
			iPlay = pPlot.getOwner()
			if iPlay > -1: self.dTerraformCount[iPlay] += 1
		iWinThreshold = self.TerraVictoryPlots()
		iPopThreshold = int (iWinThreshold / 3)
		iPopTarget = -1
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			iCount = self.dTerraformCount[iPlay]
			if iCount >= iWinThreshold:
				pPlay = gc.getPlayer(iPlay)
				# 5 = position in victoryinfo.xml
				CyGame().setWinner(pPlay.getTeam(), 5)
			elif iCount > iPopThreshold:
				iPopTarget = iPlay
		if (iPopTarget > -1) and not self.bTerraformPop:
			if iPlay == gc.getActivePlayer().getID():
				s1 = "You"
				s2 = "you"
			else:
				iCiv = gc.getPlayer(iPopTarget).getCivilizationType()
				s1 = "The " + gc.getCivilizationInfo(iCiv).getText()
				s2 = "they"
			s = "Spice production is threatened!  %s have terraformed 1%% of the planet surface.  At 3%% %s will win a Terraforming Victory!" % (s1, s2)
			s = s + "  (See the Dune Wars Concepts page in the Civilopedia)"
			self.BasicPopup(s)
			self.bTerraformPop = true
			
### SPICE VICTORY FUNCTIONS

	# Return the sum of spice resources available to each player in their capital
	def TotalSpiceOnArrakis(self):
		iCount = 0
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			pPlay = gc.getPlayer(iPlay)
			pCapital = pPlay.getCapitalCity()
			iPlayerSpice = pCapital.getNumBonuses(self.iBSpice)
			if iPlayerSpice > 0:
				iCount += pCapital.getNumBonuses(self.iBSpice)
		return int (iCount)
	
	def SpiceVictoryRequiredBonuses(self):
		iCount = self.TotalSpiceOnArrakis()
		iPercentage = self.SpiceVictoryGetPercentage()
		return int (iCount * iPercentage / 100)
		
	def SpiceVictoryGetPercentage(self):
	# Next line controls the percentage of spice that must be controlled to win
		return 85

	def SpiceVictoryFixedAmount(self):
		self.Initialize()
		xmax = CyMap().getGridWidth()
		ymax = CyMap().getGridHeight ()
	# Next line controls the fixed amount of spice that must be controlled to win
		return int (xmax * ymax / 100)
		
	# Return cached count of terraformed plots for this player
	def SpiceVictoryPlayer(self, iPlay):
		self.Initialize()
		if not self.dSpiceVictoryCount.has_key(iPlay): return 0
		return self.dSpiceVictoryCount[iPlay]

	# Check for victory by three percent of land terraformed
	# Update cached count of terraformed plots for this player
	def SpiceVictoryCheck(self):
		self.Initialize()
		if not CyGame().isVictoryValid(self.iVSpice): return
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			self.dSpiceVictoryCount[iPlay] = 0
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			if iPlay > -1: 
				pPlay = gc.getPlayer(iPlay)
				pCapital = pPlay.getCapitalCity()
				self.dSpiceVictoryCount[iPlay] = pCapital.getNumBonuses(self.iBSpice)	
		iWinFixedAmount = self.SpiceVictoryFixedAmount()
		iWinThreshold = self.SpiceVictoryRequiredBonuses()
		iPopThreshold = int (self.TotalSpiceOnArrakis() * 0.70)
		iPopTarget = -1
		for iPlay in range(gc.getMAX_CIV_PLAYERS()):
			iCount = self.dSpiceVictoryCount[iPlay]
			if iCount >= iWinFixedAmount:
				if iCount >= iWinThreshold:
					pPlay = gc.getPlayer(iPlay)
					# 6 = position in victoryinfo.xml
					CyGame().setWinner(pPlay.getTeam(), 6)
				elif iCount > iPopThreshold:
					iPopTarget = iPlay
		if (iPopTarget > -1) and not self.bSpiceVictoryPop:
			if iPlay == gc.getActivePlayer().getID():
				s1 = "You"
				s2 = "you"
			else:
				iCiv = gc.getPlayer(iPopTarget).getCivilizationType()
				s1 = "The " + gc.getCivilizationInfo(iCiv).getText()
				s2 = "they"
			s = "Spice is being monopolized!  %s are currently controlling 70%% of the spice on Arrakis. If this continues %s may win a Spice Monopoly Victory!" % (s1, s2)
			s = s + "  (See the Dune Wars Concepts page in the Civilopedia)"
			self.BasicPopup(s)
			self.bSpiceVictoryPop = true
